execute as @e[tag=scm_machine,tag=!belt,tag=!scm_sorter,tag=!storehouse] at @s run function scm:machine/common/check_lamp
#storager
execute as @e[type=item,nbt={Item:{tag:{storager:1b}}}] at @s run function scm:machine/common/storager/safe

#conveyor_belt
#物品判定
execute as @e[type=armor_stand,tag=belt] at @s run function scm:machine/common/belt/check
execute as @e[type=item,tag=belt] at @s run function scm:machine/common/belt/check0
execute as @e[type=item,tag=belt] at @s run function scm:machine/common/belt/check1
#运动
execute as @e[type=item,tag=belt] at @s run function scm:machine/common/belt/move

#mech_bit
execute as @e[tag=scm_mech_bit,tag=scm_stop] at @s run function scm:machine/common/mech_bit/stop
execute as @e[tag=scm_mech_bit,tag=!scm_stop] at @s if block ^ ^1.5 ^1 end_portal_frame run advancement grant @p only scm:slime_craft/flight_of_fancy
execute as @e[tag=scm_mech_bit,tag=!scm_stop] at @s positioned ^ ^1.5 ^ unless block ^ ^ ^1 #scm:mech_saw unless block ^ ^ ^1 #scm:mech_pump unless block ^ ^ ^1 #scm:none run tag @s add scm_1
execute as @e[tag=scm_mech_bit,tag=!scm_1] run function scm:machine/common/mech_bit/stop
execute as @e[tag=scm_mech_bit,tag=scm_1] at @s run function scm:machine/common/mech_bit/dig

#storehouse
#检查
execute as @e[tag=scm_storehouse1,tag=scm_stock_upgrade,nbt={HandItems:[{tag:{storager:1b,stockUpgrade:1}}]}] at @s positioned ^ ^0.5 ^-0.32 if entity @e[tag=scm_storehouse,tag=scm_empty,distance=..0.3,sort=nearest,limit=1] run function scm:machine/common/storager/get
execute as @e[tag=scm_storehouse1,tag=!scm_stock_upgrade,nbt={HandItems:[{tag:{storager:1b}}]},nbt=!{HandItems:[{tag:{stockUpgrade:1}}]}] at @s positioned ^ ^0.5 ^-0.32 if entity @e[tag=scm_storehouse,tag=scm_empty,distance=..0.3,sort=nearest,limit=1] run function scm:machine/common/storager/get

execute as @e[tag=scm_storehouse1,nbt={HandItems:[{tag:{upgrade:1}}]}] at @s run function scm:machine/common/storehouse/upgrade
execute as @e[tag=scm_storehouse1,nbt={HandItems:[{tag:{spanner:1b}}]}] at @s positioned ^ ^0.5 ^-0.32 run execute as @e[tag=scm_storehouse,distance=..0.3,sort=nearest,limit=1] at @s run function scm:machine/common/storehouse/change_export
execute as @e[tag=scm_storehouse1] at @s positioned ^ ^1.5 ^0.68 run function scm:machine/common/storehouse/pre_store

execute as @e[tag=scm_storehouse] at @s run function scm:machine/common/storehouse/check
#初次存储
execute as @e[tag=storehouse_north,tag=scm_empty] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_first
execute as @e[tag=storehouse_east,tag=scm_empty] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_first
execute as @e[tag=storehouse_south,tag=scm_empty] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_first
execute as @e[tag=storehouse_west,tag=scm_empty] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_first
#存储
execute as @e[tag=storehouse_north,tag=!scm_empty,tag=!stop_store] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_check0
execute as @e[tag=storehouse_east,tag=!scm_empty,tag=!stop_store] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_check0
execute as @e[tag=storehouse_south,tag=!scm_empty,tag=!stop_store] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_check0
execute as @e[tag=storehouse_west,tag=!scm_empty,tag=!stop_store] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_check0
#红石比较器
execute as @e[tag=!storehouse_north,tag=!storehouse_south,tag=scm_storehouse] at @s if block ~ ~1 ~1 comparator[facing=north,mode=compare] run function scm:machine/common/storehouse/comparator_x_north
execute as @e[tag=!storehouse_north,tag=!storehouse_south,tag=scm_storehouse] at @s if block ~ ~1 ~-1 comparator[facing=south,mode=compare] run function scm:machine/common/storehouse/comparator_x_south
execute as @e[tag=!storehouse_west,tag=!storehouse_east,tag=scm_storehouse] at @s if block ~-1 ~1 ~ comparator[facing=east,mode=compare] run function scm:machine/common/storehouse/comparator_y_east
execute as @e[tag=!storehouse_west,tag=!storehouse_east,tag=scm_storehouse] at @s if block ~1 ~1 ~ comparator[facing=west,mode=compare] run function scm:machine/common/storehouse/comparator_y_west
#输出
execute as @e[tag=storehouse_north,tag=!scm_empty,tag=!scm_stop] at @s positioned ^ ^1 ^-1 unless entity @e[type=item,distance=..0.5] run function scm:machine/common/storehouse/export
execute as @e[tag=storehouse_east,tag=!scm_empty,tag=!scm_stop] at @s positioned ^ ^1 ^-1 unless entity @e[type=item,distance=..0.5] run function scm:machine/common/storehouse/export
execute as @e[tag=storehouse_south,tag=!scm_empty,tag=!scm_stop] at @s positioned ^ ^1 ^-1 unless entity @e[type=item,distance=..0.5] run function scm:machine/common/storehouse/export
execute as @e[tag=storehouse_west,tag=!scm_empty,tag=!scm_stop] at @s positioned ^ ^1 ^-1 unless entity @e[type=item,distance=..0.5] run function scm:machine/common/storehouse/export

#container_interator
#更改种类
execute as @e[tag=scm_CI,nbt={HandItems:[{tag:{spanner:1b}}]}] at @s run function scm:machine/common/ci/change

execute as @e[tag=scm_CI] at @s positioned ~ ~1.3 ~ run function scm:machine/common/ci/pre_check

#检查是否为容器、是否满足工作条件
execute as @e[tag=scm_CI,tag=!stop] at @s run function scm:machine/common/ci/check_container
#若工作且容器有空间且不被信号停止则输入
execute as @e[tag=CI_inport,tag=!scm_stop,tag=scm_work,limit=1] run function scm:machine/common/ci/inport/basic0
#若工作且容器非空且不被信号停止则输出
execute as @e[tag=CI_export,tag=scm_work,tag=!scm_stop,limit=1] run function scm:machine/common/ci/export/basic0

#sorter
execute as @e[tag=scm_sorter] at @s run function scm:machine/common/sorter/check_lamp
execute as @e[tag=scm_sorter] run function scm:machine/common/sorter/animation
execute as @e[tag=scm_sorter] at @s run function scm:machine/common/sorter/set_fliter
#
execute as @e[tag=scm_sorter,tag=scm_empty,tag=!scm_stop,limit=1] run function scm:machine/common/sorter/basic0